recipes/urls.py
from django.urls import path

from recipes.views import *

urlpatterns = [
    path("", RecipeListView.as_view(), name="recipes_list"),
    path("<int:pk>/", RecipeDetailView.as_view(), name="recipe_detail"),
    path("<int:pk>/delete/", RecipeDeleteView.as_view(), name="recipe_delete"),
    path("new/", RecipeCreateView.as_view(), name="recipe_new"),
    path("<int:pk>/edit/", RecipeUpdateView.as_view(), name="recipe_edit"),
    path("<int:recipe_id>/ratings/", log_rating, name="recipe_rating"),
    path("shopping_items/", list_shopping_items, name="shopping_items_list"),
    path(
        "shopping_items/create/",
        create_shopping_item,
        name="shopping_item_create",
    ),
    path(
        "shopping_items/delete/",
        delete_all_shopping_items,
        name="delete_all_shopping_items",
    ),
]

# path( 1-use this pattern to match URLs with request,
#       2-when URL matches call this fxn in views.py,
#       3-the name that is used in redirect, reverse, and {% url %} tags)

scrumptious/urls.py
from django.contrib import admin
from django.urls import include, path, reverse_lazy
from django.views.generic.base import RedirectView
from django.contrib.auth import views as auth_views

urlpatterns = [
    path("admin/", admin.site.urls),
    path("recipes/", include("recipes.urls")),
    path("tags/", include("tags.urls")),
    path("accounts/login/", auth_views.LoginView.as_view(), name="login"),
    path("accounts/logout/", auth_views.LogoutView.as_view(), name="logout"),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("recipes_list")),
        name="home",
    ),
    path("meal_plans/", include("meal_plans.urls")),
]

tags/urls.py
from django.urls import path

from tags.views import (
    TagListView,
    TagDeleteView,
    TagDetailView,
    TagCreateView,
    TagUpdateView,
)

urlpatterns = [
    path("", TagListView.as_view(), name="tags_list"),
    path("<int:pk>/", TagDetailView.as_view(), name="tag_detail"),
    path("<int:pk>/delete/", TagDeleteView.as_view(), name="tag_delete"),
    path("new/", TagCreateView.as_view(), name="tag_new"),
    path("<int:pk>/edit/", TagUpdateView.as_view(), name="tag_edit"),
]

recipes/models.py
from django.db import models
from django.core.validators import MaxValueValidator, MinValueValidator
from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL


# Create your models here.
class Recipe(models.Model):
    name = models.CharField(max_length=125)
    author = models.ForeignKey(
        USER_MODEL,
        related_name="recipes",
        on_delete=models.CASCADE,
        null=True,
    )
    # one author, many recipes
    # one recipe, one author
    # related name needed so we can reference later
    # cascade bc if author is deleted, want all recipes by that author deleted
    description = models.TextField()
    image = models.URLField(null=True, blank=True)
    created = models.DateTimeField(auto_now_add=True)
    updated = models.DateTimeField(auto_now=True)
    servings = models.PositiveIntegerField(null=True)

    def __str__(self):
        return self.name + " by " + str(self.author)


class Measure(models.Model):
    name = models.CharField(max_length=30, unique=True)
    abbreviation = models.CharField(max_length=10, unique=True)

    def __str__(self):
        return self.name


class FoodItem(models.Model):
    name = models.CharField(max_length=100, unique=True)

    def __str__(self):
        return self.name


class Ingredient(models.Model):
    amount = models.FloatField(validators=[MaxValueValidator(20)])
    recipe = models.ForeignKey(
        "Recipe",
        related_name="ingredients",
        on_delete=models.CASCADE,
    )
    # one recipe, many ingredients
    # one ingredient, one recipe
    measure = models.ForeignKey("Measure", on_delete=models.PROTECT)
    # one measure, many ingredients
    # one ingredient, one measure
    # protect = cannot delete measure ??
    food = models.ForeignKey("FoodItem", on_delete=models.PROTECT)
    # one food, many ingredients
    # one ingredient, one food

    def __str__(self):
        amount = str(self.amount)
        measure = self.measure.name
        food = self.food.name
        return amount + " " + measure + " " + food


class Step(models.Model):
    recipe = models.ForeignKey(
        "Recipe",
        related_name="steps",
        on_delete=models.CASCADE,
    )
    order = models.PositiveSmallIntegerField()
    directions = models.CharField(max_length=300)
    food_items = models.ManyToManyField("FoodItem", blank=True)

    def __str__(self):
        return str(self.order) + ". " + self.directions


class Rating(models.Model):
    value = models.PositiveSmallIntegerField(
        validators=[
            MaxValueValidator(5),
            MinValueValidator(1),
        ]
    )
    recipe = models.ForeignKey(
        "Recipe",
        related_name="ratings",
        on_delete=models.CASCADE,
    )


class ShoppingItem(models.Model):
    user = models.ForeignKey(
        USER_MODEL,
        related_name="shopping_item",
        on_delete=models.CASCADE,
        # if user is deleted, want all shopping items deleted
        null=True,
    )
    # one user, many shopping items
    # one shopping item, one user
    food_item = models.ForeignKey(
        "FoodItem", on_delete=models.PROTECT, null=True
    )
    # one food item, many shopping item (lists)
    # one shopping item, one food item

    def __str__(self):
        return f"{self.user}'s {self.food_item}"

recipes/forms.py
from django import forms

# try:
from recipes.models import Recipe


# class RecipeForm(forms.ModelForm):
#     class Meta:
#         model = Recipe
#         fields = [
#             "name",
#             "author",
#             "description",
#             "image",
#         ]


# except Exception:
#     pass


from recipes.models import Rating


class RatingForm(forms.ModelForm):
    class Meta:
        model = Rating
        fields = ["value"]

recipes/views.py
from django.shortcuts import redirect, render
from django.urls import reverse_lazy
from django.contrib.auth.decorators import login_required
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, DeleteView, UpdateView
from django.views.generic.list import ListView
from django.contrib.auth.mixins import LoginRequiredMixin
from django.db import IntegrityError

from recipes.forms import RatingForm

# try:
# from recipes.forms import RecipeForm
from recipes.models import *

# except Exception:
#     RecipeForm = None
#     Recipe = None


def log_rating(request, recipe_id):
    if request.method == "POST":
        form = RatingForm(request.POST)
        if form.is_valid():
            try:
                rating = form.save(commit=False)
                rating.recipe = Recipe.objects.get(pk=recipe_id)
                rating.save()
            except Recipe.DoesNotExist:
                return redirect("recipes_list")
    return redirect("recipe_detail", pk=recipe_id)


class RecipeListView(ListView):
    model = Recipe
    template_name = "recipes/list.html"
    paginate_by = 10


class RecipeDetailView(DetailView):
    model = Recipe
    template_name = "recipes/detail.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["rating_form"] = RatingForm()

        # Create a new empty list and assign it to a variable
        foods = []

        # For each item in the user's shopping items, which we
        # can access through the code
        # self.request.user.shopping_items.all()
        for item in self.request.user.shopping_item.all():
            # Add the shopping item's food to the list
            foods.append(item.food_item)

        # The self.request.GET property is a dictionary
        # Get the value out of there associated with the
        #   key "servings"
        # Store in the context dictionary with the key
        #   "servings"
        context["servings"] = self.request.GET.get("servingss")

        # Put that list into the context
        context["food_in_shopping_list"] = foods

        return context


class RecipeCreateView(LoginRequiredMixin, CreateView):
    model = Recipe
    template_name = "recipes/new.html"
    fields = ["name", "description", "servings", "image"]
    success_url = reverse_lazy("recipes_list")

    def form_valid(self, form):
        form.instance.author = self.request.user
        return super().form_valid(form)


class RecipeUpdateView(LoginRequiredMixin, UpdateView):
    model = Recipe
    template_name = "recipes/edit.html"
    fields = ["name", "author", "description", "servings", "image"]
    success_url = reverse_lazy("recipes_list")


class RecipeDeleteView(LoginRequiredMixin, DeleteView):
    model = Recipe
    template_name = "recipes/delete.html"
    success_url = reverse_lazy("recipes_list")


@login_required
def list_shopping_items(request):
    context = {
        "ShoppingItems_list": ShoppingItem.objects.filter(user=request.user),
    }
    return render(request, "shopping_items/list.html", context)
    # why didn't recipes/shopping_items/list.html work???
    # because recipes in recipes/list.html is the template, not the app
    # so shopping_items in shopping_items/list.html is the template
    # so no need to callout recipes app


@login_required
def create_shopping_item(request):
    # Get the ingredient_id from the POST
    ingredient_id = request.POST.get("ingredient_id")
    # ingredient_id is defined in detail.html, form

    # Get the specific ingredient from the Ingredient model
    ingredient = Ingredient.objects.get(id=ingredient_id)

    # Get the current user
    user = request.user
    try:
        # Create the new shopping item in the database
        ShoppingItem.objects.create(
            food_item=ingredient.food,
            user=user,
        )
    # Catch the error if its already in there
    except IntegrityError:
        # Don't do anything with the error
        pass

    # Go back to the recipe page
    return redirect("recipe_detail", pk=ingredient.recipe.id)


@login_required
def delete_all_shopping_items(request):
    ShoppingItem.objects.filter(user=request.user).delete()
    return redirect("shopping_items_list")

recipes/templates/recipes/delete.html
{% extends 'base.html' %}

{% block content %}

{% comment %} {% load static %}

<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Edit {{ recipe.name }} - Scrumptious</title>
  <link rel="stylesheet" href="{% static 'css/app.css' %}">
</head>

<body>
  <header>
    <nav>
      <ul>
        <li>
          <a href="{% url 'home' %}">Scrumptious</a>
        </li>
        <li>
          <a href="{% url 'tags_list' %}">Tags</a>
        </li>
        <li>
          <a href="{% url 'admin:index' %}">Admin</a>
        </li>
        <li>
          <a href="{% url 'recipe_new' %}">Write a recipe</a>
        </li>
      </ul>
    </nav>
  </header> {% endcomment %}
  <main>
    <div class="delete-form">
      <form method="post">
        {% csrf_token %}
        <p>Are you sure you want to delete "{{ recipe }}"?</p>
        {{ form.as_p }}
        <div>
          <button class="button">Delete</button>
        </div>
      </form>
    </div>
  </main>
{% endblock content %}
{% comment %} </body>

</html> {% endcomment %}

recipes/templates/recipes/detail.html
{% extends 'base.html' %}
{% block content %}
    {% load resize_to %}
    {% load markdownify %}
    <main class="recipe-detail">
        <div>
            <a href="{% url 'recipe_edit' recipe.id %}">Edit</a>
            <a href="{% url 'recipe_delete' recipe.id %}">Delete</a>
        </div>
        {% if recipe.image %}<img src="{{ recipe.image }}" class="pull-right">{% endif %}
        <h1>{{ recipe.name }}</h1>
        <h2>by: {{ recipe.author | default_if_none:"Unknown" }}</h2>
        <p>
            Created on {{ recipe.created }} |
            Updated on {{ recipe.updated }}
        </p>
        <h2>Rating</h2>
        <form method="post" action="{% url 'recipe_rating' recipe.id %}">
            {% csrf_token %}
            <div class="rating-form-grid">
                {{ rating_form.as_p }}
                <button class="button">Rate</button>
            </div>
        </form>
        <p>
            Tags:
            {% for tag in recipe.tags.all %}
                <a href="{% url 'tag_detail' tag.pk %}">#{{ tag.name }}</a>
            {% endfor %}
        </p>
        <h2>Description:</h2>
        <div>{{ recipe.description | markdownify }}</div>
        <h2>Ingredients</h2>
        {% comment %}
            how does the detail.html page know which recipe it needs to refer to?
            when you go to a detail page, the URL link also provides the pk or id from DB table
            so once you're in the detail page of recipe.pk, any recipes are referred to recipe.pk
        {% endcomment %}
        {% if recipe.servings %}
            Servings: {{ servings | default_if_none:recipe.servings }}
            <form method="GET">
                <input required type="number" name="servingss" min="0">
                {% comment %}
                    input value being set to name="servingss"
                    input value is linked to the below:
                    views.py class RecipeDetailView self.request.GET.get("servingss")
                    also linked to URL
                    in views.py, context["servings"] is linked to servings under if statement
                {% endcomment %}
                <button class="button">Update</button>
            </form>
        {% endif %}
        <table>
            <thead>
                <tr>
                    <th colspan="2">Amount</th>
                    <th>Food item</th>
                </tr>
            </thead>
            <tbody>
                {% for ingredient in recipe.ingredients.all %}
                    <tr>
                        {% comment %} <td>{{ ingredient.amount }}</td> {% endcomment %}
                        <td>{{ ingredient|resize_to:servings }}</td>
                        <td>{{ ingredient.measure.name }}</td>
                        <td>{{ ingredient.food.name }}</td>
                        <td>
                            {% if ingredient.food not in food_in_shopping_list %}
                                {% comment %}
                                food_in_shopping_list pulled from views.py, class RecipeDetailView
                                {% endcomment %}
                                <form method="post" action={% url 'shopping_item_create' %}>
                                    {% comment %}
                                  use POST when creating, updating, deleting
                                  action tells browser what URL to send data to
                                  if no action, then browser POSTs back to current URL
                                    like for CreateView, DeleteView, UpdateView
                                  in this case, DetailView has no POST fxn
                                    it can only respond to GET requests
                                    so we send to shopping_item_create
                                    which HAS a POST fxn
                                  {% url 'shopping_item_create' % }
                                    is equivalent to
                                    recipes/shopping_items/create
                                    {% endcomment %}
                                    {% csrf_token %}
                                    <input type="hidden" name="ingredient_id" value="{{ ingredient.id }}">
                                    {% comment %}
                                  if id value of ingredient is 4, then {{ ingredient.id }} = 4
                                  id is hidden bc it's defaulted to actually show on the html page
                                    {% endcomment %}
                                    <button class="button">+ shopping list</button>
                                </form>
                            {% else %}
                                <p>in your list</p>
                            {% endif %}
                        </td>
                    </tr>
                {% endfor %}
            </tbody>
        </table>
        <h2>Steps</h2>
        <ol>
            {% for step in recipe.steps.all %}<li>{{ step.directions }}</li>{% endfor %}
        </ol>
    </main>
{% endblock content %}

recipes/templates/recipes/edit.html
{% extends 'base.html' %}

{% block content %}
  <main class="recipe-form">
    <form method="post">
      {% csrf_token %}
      {{ form.as_p }}
      <div class="control">
        <button class="button">Update</button>
      </div>
    </form>
  </main>
{% endblock content %}

recipes/templates/recipes/list.html
{% extends 'paginate.html' %}
{% comment %} {% extends 'base.html' %} {% endcomment %}
{% comment %} {% load static %}

<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Scrumptious</title>
  <link rel="stylesheet" href="{% static 'css/app.css' %}">
</head>

<body>
  <header>
    <nav>
      <ul>
        <li>
          <a href="{% url 'home' %}">Scrumptious</a>
        </li>
        <li>
          <a href="{% url 'tags_list' %}">Tags</a>
        </li>
        <li>
          <a href="{% url 'admin:index' %}">Admin</a>
        </li>
        <li>
          <a href="{% url 'recipe_new' %}">Write a recipe</a>
        </li>
      </ul>
    </nav>
    <div class="pagination">
      <span class="step-links">
        {% if page_obj.has_previous %}
          <a href="?page=1">&laquo; first</a>
          <a href="?page={{ page_obj.previous_page_number }}">previous</a>
        {% endif %}

        <span class="current">Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}.</span>

        {% if page_obj.has_next %}
          <a href="?page={{ page_obj.next_page_number }}">next</a>
          <a href="?page={{ page_obj.paginator.num_pages }}">last &raquo;</a>
        {% endif %}
      </span>
    </div>
</header> {% endcomment %}
{% comment %} {% block pagination %}
  <div class="pagination">
    <span class="step-links">
      {% if page_obj.has_previous %}
        <a href="?page=1">&laquo; first</a>
        <a href="?page={{ page_obj.previous_page_number }}">previous</a>
      {% endif %}

      <span class="current">Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}.</span>

      {% if page_obj.has_next %}
        <a href="?page={{ page_obj.next_page_number }}">next</a>
        <a href="?page={{ page_obj.paginator.num_pages }}">last &raquo;</a>
      {% endif %}
    </span>
  </div>
{% endblock pagination %} {% endcomment %}
{% block content %}
    <main class="recipe-grid">
        {% for recipe in recipe_list %}
            <div class="recipe-card">
                <h2 class="recipe-card-title">
                    <a href="{% url 'recipe_detail' recipe.pk %}">{{ recipe.name }}</a>
                </h2>
                <p class="recipe-card-date">{{ recipe.updated }}</p>
            </div>
        {% endfor %}
    </main>
{% endblock content %}
{% comment %} </body>

</html> {% endcomment %}

recipes/templates/recipes/new.html
{% extends 'base.html' %}
{% block content %}
    {% comment %} {% load static %}

<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>New Recipe - Scrumptious</title>
  <link rel="stylesheet" href="{% static 'css/app.css' %}">
</head>

<body>
  <header>
    <nav>
      <ul>
        <li>
          <a href="{% url 'home' %}">Scrumptious</a>
        </li>
        <li>
          <a href="{% url 'tags_list' %}">Tags</a>
        </li>
        <li>
          <a href="{% url 'admin:index' %}">Admin</a>
        </li>
        <li>
          <a href="{% url 'recipe_new' %}">Write a recipe</a>
        </li>
      </ul>
    </nav>
    </header> {% endcomment %}
    <main class="recipe-form">
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <div class="control">
                <button class="button">Create</button>
            </div>
        </form>
    </main>
{% endblock content %}
{% comment %} </body>

</html> {% endcomment %}